import sys
import re
from collections import deque, defaultdict, Counter
import random, string, datetime, time

INF = 10**18

#区切る
def tree_split(p):
    # ""内の括弧と空白を削除
    p = list(p)
    newp = []
    qcnt = 0
    for i,t in enumerate(p):
        if qcnt%2 and t in '()[]{}':
            continue
        elif t in '()[]{}' and i-1>=0 and i+1<len(p) and p[i-1] == p[i+1] == "'":
            # '('
            continue
        elif t == '\\' and i-1>=0 and p[i-1] == '\\':
            # \\
            p[i] = '@'
            continue
        elif t == '"':
            if i-3>=0 and p[i-3:i+1] == ['\\', '@', '\\', '"']:
                # \@\" もとは \\\"
                continue
            elif i-2>=0 and i+1<len(p) and p[i-2:i+2] == ["'", '\\', '"', "'"]:
                # '\"'
                continue
            else:
                qcnt += 1
        newp.append(t)
    p = ''.join(newp)
    for s in '()[]{},':
        p = p.replace(s, ' ' + s + ' ')
    tmp = p.split('\\')
    tmp = ''.join(tmp)
    return tmp.split()

def lex_split(p):
    for s in '()[]{},':
        p = p.replace(s, ' ' + s + ' ')
    tmp = p.split('\\')
    tmp = ''.join(tmp)
    tmp = re.split(r', Loc', tmp)
    for i,x in enumerate(tmp):
        tmp[i] = x.split()
        if tmp[i][0] == 'Loc':
            tmp[i] = tmp[i][1:]
    return tmp

class SrcSpan:
    def __init__(self, data = ['',-1,-1,-1,-1]):
        self.filename = data[0]
        self.lcdata = list(map(int, data[1:5])) #[startline,startcolumn,endline,endcolumn]
    def __str__(self):
        tmp = ''
        for x in self.lcdata:
            tmp += str(x) + ' '
        return f'{self.filename} {tmp}'
    def __contains__(self,other):
        # otherがselfの中に完全に含まれているか
        if self.lcdata[3] == INF:
            # rootノード
            return True
        if self.filename != other.filename:
            # filenameが違う場合、明らかに含まれていない
            return False
        if self.lcdata[0] > other.lcdata[0] or (self.lcdata[0] == other.lcdata[0] and self.lcdata[1] > other.lcdata[1]):
            # 左端がはみ出ている
            return False
        if self.lcdata[2] < other.lcdata[2] or (self.lcdata[2] == other.lcdata[2] and self.lcdata[3] < other.lcdata[3]):
            # 右端がはみ出ている
            return False
        return True
    def is_R2(self, other):
        # otherとselfの接点が完全にない（かさなっていなければTrue）
        if self.lcdata[3] == INF:
            #rootノード
            return False
        if self.filename != other.filename:
            return True
        def lt(a,b):
            s0,e0 = a
            s1,e1 = b 
            # (s0,e0) が (s1,e1) より先にあるか
            if s0 < s1:
                return True
            elif s0 > s1:
                return False
            else:
                return e0 < e1
        
        l = self.lcdata[:2]
        r = self.lcdata[2:]
        L = other.lcdata[:2]
        R = other.lcdata[2:]
        # R < l （閉区間なので l == R の時は接点がない）
        if l == R or lt(R,l):
            return True
        # r < L （閉区間なので r == L の時は接点がない）
        if r == L or lt(r,L):
            return True
        return False
    def line_length(self):
        return self.lcdata[2]-self.lcdata[0]+1

class Node:
    def __init__(self, name = '', parent = None):
        self.name = name
        self.parent = parent
        self.children = []
        self.terminal = ''
        self.srcspan = None
        self.srcinfopoints = []
    def __str__(self):
        return f'{self.name} {self.srcspan} '

class Token:
    def __init__(self, name = '', srcspan = None, idx = -1):
        self.name = name
        self.srcspan = srcspan
        self.id = idx
        self.nex = None
    def __lt__(self, other):
        # self < other
        return self.id < other.id
    def __str__(self):
        return f'{self.id} {self.name} '

def isint(s):  # 整数値を表しているかどうかを判定
    try:
        int(s, 10)  # 文字列を実際にint関数で変換してみる
    except ValueError:
        return False
    else:
        return True

ignore_words = ['LanguagePragma',
                'OptionsPragma',
                'AnnModulePragma',
                'ImportDecl']
start_time = time.time() #速度計測用
FILE_NUMBER = int(sys.argv[1])
GAP_SYN = int(sys.argv[2])
# if GAP_SYN == 0:
#     print('ifgap')
# elif GAP_SYN == 1:
#     print('appgap')
# elif GAP_SYN == 2:
#     print('casegap')
clone_length_lim = int(sys.argv[3])
root = Node('root')
root.srcspan = SrcSpan(data = ['',1,1,INF,INF])
tokens = []
pre_token = Token('', SrcSpan(), -1)
for file_idx in range(FILE_NUMBER):
    tree = input()

    tree = tree[1:len(tree)-1] #先頭と末尾の「"」を削除 
    if not '7OeYYKz0SeerAGPJfD' in tree:
        print(tree)
        exit(-1)
    tree,lex = re.split(r'7OeYYKz0SeerAGPJfD', tree)
    tree = tree_split(tree)
    lex = lex[1:len(lex)-1]
    lex = lex_split(lex)

    # treeの解析
    par = root
    now = Node('', par)
    par.children.append(now)
    ignore_cnt = 0
    i = 0
    d = defaultdict(int)
    for x in tree:
        if x in '([{)]}':
            d[x] += 1
    if d['(']!=d[')'] or d['[']!=d[']'] or d['{']!=d['}']:
        print(f'bracket error file number: {file_idx}', file=sys.stderr)
        # print(tree)
        # for k in sorted(list(d)):
        #     print(k,d[k])
        # exit()
    # continue

    while i < len(tree):
        x = tree[i]
        if ignore_cnt:
            if x in '([{':
                ignore_cnt += 1
            elif x in ')]}':
                ignore_cnt -= 1
        elif x in '([{':
            if tree[i+1] in ignore_words:
                ignore_cnt += 1
                i += 1
            elif tree[i+1] == 'srcInfoSpan':
                # 字句情報を追加
                i += 3
                if not isint(tree[i+1]):
                    # (-1)(-1)(-1)(-1)になってるっぽい
                    now.srcspan = SrcSpan()
                    i += 15
                else:
                    for j in range(i+1,i+5):
                        if not isint(tree[j]):
                            print(tree[i-100:i+100])
                            exit()
                    now.srcspan = SrcSpan(tree[i:i+5])
                    i += 7
                while tree[i] != ']':
                    now.srcinfopoints.append(SrcSpan(tree[i+1:i+6]))
                    i += 6
                    if tree[i] == ',':
                        i += 1
                i += 1 # ] 分次へ進む
            else:
                # 子ノードを追加
                par = now
                now = Node('', par)
                par.children.append(now)
        elif x in ')]}':
            # 1つ上へ戻る
            par = par.parent
            if par == None:
                print(i, tree[i-100:i+100])
                exit()
            now = now.parent
        elif x == ',':
            # 兄弟を追加
            now = Node('', par)
            par.children.append(now)
        # elif x == 'Nothing' or x == 'Boxed':
        #     pass
        elif x[0] == '"':
            # 終端記号を追加
            now.terminal = x[1:len(x)-1]
        elif not now.name:
            # 括弧直後のノード名
            now.name += x
        # else:
        #     print(i,x)
        i += 1

    # lex(字句列)のパース
    for i,obj in enumerate(lex):
        now_span = SrcSpan(obj[4:9])
        now_token = Token(obj[12], now_span, pre_token.id+1)
        pre_token.nex = now_token
        pre_token = now_token
        tokens.append(now_token)
    # ファイルの最後のtokenの後にダミーtokenを格納
    tmp = file_idx
    name = []
    while tmp:
        name.append(chr(ord('a') + tmp%26))
        tmp //= 26
    dummy_name = ''.join(['Z']*10 + name[::-1])
    now_token = Token(dummy_name, SrcSpan(), pre_token.id+1)
    tokens.append(now_token)
    pre_token.nex = now_token
    pre_token = now_token
    # print(f'{file_idx} parsed',file=sys.stderr)

# print(f'module number:{len(root.children)}')
# print(f'module number:{len(root.children)}', file=sys.stderr)
# print(f'token number:{len(tokens)}')
# print(f'token number:{len(tokens)}', file=sys.stderr)

# # ASTのデバッグ出力
# q = deque([root])
# while q:
#     u = q.popleft()
#     tmp = ''
#     for v in u.children:
#         if v.name == '':
#             continue
#         tmp += v.name + ','
#         q.append(v)
#     src = u.srcspan
#     print(f'[name]: {u.name}, [terminal]: {u.terminal}, [srcspan]: {src}')
#     print(f'[children]: {tmp}')
#     print()


# # 字句列のデバッグ出力
# for token in tokens:
#     src = token.srcspan
#     print(token, str(token.srcspan))

# SA-IS (O(nlogn))
# s: 文字列
def sais(s):
    uniq = list(set(s))
    uniq.sort()
    return sais_rec(list(map({e: i+1 for i, e in enumerate(uniq)}.__getitem__, s)), len(uniq))
def sais_rec(lst, num):
    L = len(lst)
    if L < 2:
        return lst + [0]
    lst = lst + [0]
    L += 1
    res = [-1] * L
    t = [1] * L
    for i in range(L-2, -1, -1):
        t[i] = 1 if (lst[i] < lst[i+1] or (lst[i] == lst[i+1] and t[i+1])) else 0
    isLMS = [t[i-1] < t[i] for i in range(L)]
    LMS = [i for i in range(1, L) if t[i-1] < t[i]]
    LMSn = len(LMS)

    count = Counter(lst)
    tmp = 0
    cstart = [0]*(num+1)
    cend = [0]*(num+1)
    for key in range(num+1):
        cstart[key] = tmp
        cend[key] = tmp = tmp + count[key]

    cc_it = [iter(range(e-1, s-1, -1)) for s, e in zip(cstart, cend)]
    for e in reversed(LMS):
        res[next(cc_it[lst[e]])] = e

    cs_it = [iter(range(s, e)) for s, e in zip(cstart, cend)]
    ce_it = [iter(range(e-1, s-1, -1)) for s, e in zip(cstart, cend)]
    for e in res:
        if e > 0 and not t[e-1]:
            res[next(cs_it[lst[e-1]])] = e-1
    for e in reversed(res):
        if e > 0 and t[e-1]:
            res[next(ce_it[lst[e-1]])] = e-1

    name = 0; prev = -1
    pLMS = {}
    for e in res:
        if isLMS[e]:
            if prev == -1 or lst[e] != lst[prev]:
                name += 1; prev = e
            else:
                for i in range(1, L):
                    if lst[e+i] != lst[prev+i]:
                        name += 1; prev = e
                        break
                    if isLMS[e+i] or isLMS[prev+i]:
                        break
            pLMS[e] = name-1

    if name < LMSn:
        sublst = [pLMS[e] for e in LMS if e < L-1]
        ret = sais_rec(sublst, name-1)

        LMS = list(map(LMS.__getitem__, reversed(ret)))
    else:
        LMS = [e for e in reversed(res) if isLMS[e]]

    res = [-1] * L

    cc_it = [iter(range(e-1, s-1, -1)) for s, e in zip(cstart, cend)]
    for e in LMS:
        res[next(cc_it[lst[e]])] = e

    cs_it = [iter(range(s, e)) for s, e in zip(cstart, cend)]
    ce_it = [iter(range(e-1, s-1, -1)) for s, e in zip(cstart, cend)]

    for e in res:
        if e > 0 and not t[e-1]:
            res[next(cs_it[lst[e-1]])] = e-1
    for e in reversed(res):
        if e > 0 and t[e-1]:
            res[next(ce_it[lst[e-1]])] = e-1
    return res


# ソート用文字列を数値へ変換
uniq = set()
for token in tokens:
    uniq.add(token.name)
# print(f'uniq_token_len: {len(uniq)}', file=sys.stderr)
token_to_num_dict = dict()
for i,x in enumerate(sorted(list(uniq))):
    token_to_num_dict[x] = i+1
# token.name を 数値に変換
num_list_tokens = [token_to_num_dict[x.name] for x in tokens]
suffix_array = list(sais(num_list_tokens)[1:])

# print('created suffix_array', file=sys.stderr)

# return(iftype, nx)
def search_ifroot(ifroot, target_token):
    ch_token = None
    contain_tokens = []
    iftype = -1
    for i,x in enumerate(ifroot.children):
        # target_tokenがif節、then節、else節どれに入っているか
        if target_token.srcspan and x.srcspan and target_token.srcspan in x.srcspan:
            ch_token = x
            iftype = i
            break
    if not ch_token:
        return (-1,[])
    for token in tokens:
        if not token.srcspan:
            continue
        if token.srcspan in ch_token.srcspan:
            contain_tokens.append(token)
        elif contain_tokens:
            break
    contain_tokens = [] if not contain_tokens else [contain_tokens[0],contain_tokens[-1]]
    return (iftype, contain_tokens[:])

# どちらもthen節,else節に含まれるかどうか
# iftype[0] = 'if', iftype[1] = 'then' , iftype[2] = else
# return (lasttoken0, lasttoken1, iftype)
def if_compare(token_0, token_1):
    gaps = [[], []]
    iftypes = [-1, -1]
    for i,token in enumerate([token_0, token_1]):
        q = deque([root])
        while q:
            u = q.popleft()
            for v in u.children:
                if not v.srcspan or (token.srcspan and not token.srcspan in v.srcspan):
                    continue
                if v.name == 'If':
                    iftypes[i], gaps[i] = search_ifroot(v, token)
                    break
                q.append(v)

    if iftypes[0] != iftypes[1] or not iftypes[0] in [1,2]:
        return []
    return gaps


# def search_app_range(node):
#     contain_tokens = []
#     for token in tokens:
#         if token.srcspan and node.srcspan and token.srcspan in node.srcspan:
#             contain_tokens.append(token)
#     contain_tokens = [] if not contain_tokens else [contain_tokens[0],contain_tokens[-1]]
#     return (contain_tokens[:])

def app_compare(token_0, token_1):
    gaps = [[], []]
    for i,token in enumerate([token_0, token_1]):
        q = deque([root])
        while q:
            u = q.popleft()
            for v in u.children:
                if not v.srcspan or (token.srcspan and not token.srcspan in v.srcspan):
                    continue
                if 'App' == v.name:
                    gaps[i] = [] # 初期化
                    for tk in tokens:
                        if not tk.srcspan or not v.srcspan:
                            continue
                        if tk.srcspan in v.srcspan:
                            gaps[i].append(tk)
                        elif gaps[i]:
                            break
                    # assert
                    for j in range(len(gaps[i])-1):
                        if gaps[i][j].nex != gaps[i][j+1]:
                            for tk in gaps[i]:
                                print(tk)
                            exit()
                    gaps[i] = [] if not gaps[i] else [gaps[i][0],gaps[i][-1]]
                q.append(v)
    return gaps

def search_case_range(case_root, target_token):
    alt_node = None
    contain_tokens = []
    for i,x in enumerate(case_root.children):
        # target_tokenが条件部分でないかどうか
        if i and x and x.srcspan and target_token.srcspan in x.srcspan:
            alt_node = x
            break
    if not alt_node or len(alt_node.children) < 2:
        return []
    target_rhs = alt_node.children[1]
    if target_rhs and target_rhs.srcspan and target_token.srcspan in target_rhs.srcspan:
        for token in tokens:
            if not token.srcspan:
                continue
            if token.srcspan in target_rhs.srcspan:
                contain_tokens.append(token)
            elif contain_tokens:
                break
        contain_tokens = [] if not contain_tokens else [contain_tokens[0],contain_tokens[-1]]
        return (contain_tokens[:])
    return []

# どちらもcase文のaltに含まれるかどうか
def case_compare(token_0, token_1):
    gaps = [[], []]
    for i,token in enumerate([token_0, token_1]):
        q = deque([root])
        while q:
            u = q.popleft()
            for v in u.children:
                if not v.srcspan or (token.srcspan and not token.srcspan in v.srcspan):
                    continue
                if 'Case' == v.name:
                    gaps[i] = search_case_range(v, token)
                q.append(v)
    return gaps

def all_syntax_compare(token_0,  token_1):
    nodes = [[], []]
    for i,token in enumerate([token_0, token_1]):
        q = deque([root])
        while q:
            u = q.popleft()
            for v in u.children:
                if not v.srcspan or (token.srcspan and not token.srcspan in v.srcspan):
                    # v(node)はtokenの範囲外
                    continue
                nodes[i].append(v)
                q.append(v)
    gaps = [[],[]]
    for node_i in nodes[0][::-1]:
        for node_j in nodes[1][::-1]:
            if node_i.name == node_j.name:
                for idx,nd in enumerate([node_i, node_j]):
                    for tk in tokens:
                        if not tk.srcspan or not nd.srcspan:
                            continue
                        if tk.srcspan in nd.srcspan:
                            gaps[idx].append(tk)
                        elif gaps[idx]:
                            break
                if len(gaps[0]) <= 1 or len(gaps[1]) <= 1:
                    gaps = [[],[]]
                    continue
                return gaps
    return gaps

clone = [[[],[]] for _ in range(len(suffix_array))]
gap_tokens = [[set(), set()] for _ in range(len(suffix_array))]
LCP = [0]*(len(suffix_array)-1)
for i in range(len(suffix_array)-1):
    now_token_0 = tokens[suffix_array[i]]
    now_token_1 = tokens[suffix_array[i+1]]
    skipped_token_len = [0,0]
    # if i%1000==0:
    #     print(f'compare {i+1} ~', file=sys.stderr)
    while now_token_0.name and now_token_1.name:
        # 追い越しチェック
        if now_token_0.id >= suffix_array[i+1] and now_token_1.id >= suffix_array[i]:
            break
        if now_token_0.name == now_token_1.name:
            now_token_0 = now_token_0.nex
            now_token_1 = now_token_1.nex
            LCP[i] += 1
        else:
            if GAP_SYN == 0:
                gaps = if_compare(now_token_0, now_token_1)
            elif GAP_SYN == 1:
                gaps = app_compare(now_token_0, now_token_1)
            elif GAP_SYN == 2:
                gaps = case_compare(now_token_0, now_token_1)
            elif GAP_SYN == 3:
                gaps = all_syntax_compare(now_token_0, now_token_1)

            if not gaps or not gaps[0] or not gaps[1]:
                break
            # nodeの先頭がsuffix_arrayの先頭より前
            if gaps[0][0].id < suffix_array[i] or gaps[1][0].id < suffix_array[i+1]:
                break
            # 追い越しチェック
            if gaps[0][-1].id >= suffix_array[i+1] and gaps[1][-1].id >= suffix_array[i]:
                break
            # どちらも同じ左端から始まっていない
            if gaps[0][0].id - suffix_array[i] - skipped_token_len[0] != gaps[1][0].id - suffix_array[i+1] - skipped_token_len[1]:
                break
            LCP[i] += gaps[0][0].id - now_token_0.id + 1
            for j in range(2):
                skipped_token_len[j] += gaps[j][-1].id - gaps[j][0].id + 1
            # ギャップとして飛ばしたtokenを記録
            for k in range(now_token_0.id, gaps[0][-1].id+1):
                gap_tokens[i][0].add(tokens[k])
            for k in range(now_token_1.id, gaps[1][-1].id+1):
                gap_tokens[i][1].add(tokens[k])
            now_token_0 = gaps[0][-1].nex
            now_token_1 = gaps[1][-1].nex
    # 一致したtokenをリストクローンへ格納（now_token_xは最後の次のトークン）
    j = suffix_array[i]
    while tokens[j] != now_token_0:
        clone[i][0].append(tokens[j])
        j += 1
    j = suffix_array[i+1]
    while tokens[j] != now_token_1:
        clone[i][1].append(tokens[j])
        j += 1

# print('end compare', file=sys.stderr)
def is_rhseq(node, token):
    return 'Rhs' in node.name and 'Equal' in token.name
clone_set = set()

# 構文的に不完全な部分の削除
for i,lcp in enumerate(LCP):
    # if i%1000==0:
    #     print(f'del {i+1} ~', file=sys.stderr)
    if lcp < clone_length_lim:
        # 長さが閾値以下超えていない
        continue
    new_clone = [[],[]]
    is_gapped_clone = [0,0]
    ng = 0

    # print(i)
    # for j in range(2):
    #     retst = ''
    #     for to in clone[i][j]:
    #         retst += str(to)
    #     print(retst)
    # print()

    for j in range(2):
        filename = clone[i][j][0].srcspan.filename
        startline, startcolumn = clone[i][j][0].srcspan.lcdata[:2]
        endline, endcolumn = clone[i][j][-1].srcspan.lcdata[2:]
        clone_srcspan = SrcSpan([filename, startline, startcolumn, endline, endcolumn])
        # クローンに対応するnodeをretに格納
        ret = []
        target_que = deque([root])
        while target_que:
            nownode = target_que.popleft()
            if not nownode or not nownode.srcspan:
                continue
            if nownode.srcspan in clone_srcspan:
                # R1
                ret.append(nownode)
            elif nownode.srcspan.is_R2(clone_srcspan):
                # R2
                continue
            else:
                # R3
                for subnode in nownode.children:
                    target_que.append(subnode)
        # nodeとtoken列の位置関係を調査し、閾値以下のものを削除する
        for node in ret:
            now_contain = []
            for token in clone[i][j]:
                if not token or not token.name:
                    continue
                if token.srcspan and token.srcspan in node.srcspan and not is_rhseq(node,token):
                    now_contain.append(token)
            if len(now_contain) < clone_length_lim:
                ng = 1
                continue
            for token in now_contain:
                if token in gap_tokens[i][j]:
                    is_gapped_clone[j] = 1
                new_clone[j].append(token)
        new_clone[j].sort()
        # 削除した結果、とぎれとぎれになっているものはクローンとして認めない
        for k in range(len(new_clone[j])-1):
            if new_clone[j][k].nex != new_clone[j][k+1]:
                new_clone[j] = []
                break
    if ng or not new_clone[0] or not new_clone[1]:
        continue
    clone_pair = []
    for j in range(2):
        clone_pair.append(tuple([1 if min(is_gapped_clone) == 1 else 0, new_clone[j][0].srcspan.filename, new_clone[j][0].srcspan.lcdata[0], new_clone[j][0].srcspan.lcdata[1], new_clone[j][-1].srcspan.lcdata[2], new_clone[j][-1].srcspan.lcdata[3]]))
    clone_pair.sort()
    clone_set.add(tuple(clone_pair))
# print('end del', file=sys.stderr)

# 出力
# print(f'clone_length_lim: {clone_length_lim}')
gap_clones = []
type2_clones = []
for i,clone_pair in enumerate(sorted(list(clone_set), reverse=True)):
    ret_st = ''
    for clone_piece in clone_pair:
        is_gapped_clone, path,*lc = clone_piece
        if not path:
            continue
        if path[0] == '"':
            path = path[1:len(path)-1]
        with open(path) as f:
            lines = f.readlines()
        res = ''
        for row in range(lc[0]-1,lc[2]):
            if row == lc[0]-1:
                res += ''.join(lines[row][lc[1]-1:])
            elif row == lc[2]-1:
                res += ''.join(lines[row][:lc[3]])
            else:
                res += ''.join(lines[row])
        ret_st += path + ' '
        for x in lc:
            ret_st += str(x) + ' '
        ret_st += '   '
    ret_st += '\n'
        # ret_st += res + '\n'
    if is_gapped_clone:
        gap_clones.append(ret_st)
    else:
        type2_clones.append(ret_st)

# print(f'number of gap clone: {len(gap_clones)}', file=sys.stderr)
print(f'number of gap clone: {len(gap_clones)}')
# print(f'number of type2 clone: {len(type2_clones)}',file=sys.stderr)
print(f'number of type2 clone: {len(type2_clones)}')
print()
for i,st in enumerate(gap_clones,1):
    print(f'gap clone {i}')
    print(st)
for i,st in enumerate(type2_clones, 1):
    print(f'type2 clone {i}')
    print(st)
end_time = time.time()
# print(datetime.timedelta(seconds=end_time-start_time), file=sys.stderr)
# print(LCP)
